struct SIGNAL_INFO
{
    const char* pName;
    bool bIsInput;
    int nDataType;  //0:bool 1:byte 2:word 3:int 4:dword 5:dint 6:real 7:double
    int nUIButton; //0:not UI button 1:forward 2:backwoard 3:left 4:right 5:extend1 6:extend2: 7extend3
    const char* pButtonName;
};

static SIGNAL_INFO signalInfos[]
{
    // inputs
    { "buttonValue", true, 0, 5 },

    // outputs
    { "wheelLSpeed", false, 5, 0, nullptr},
    { "wheelRSpeed", false, 5, 0, nullptr},
};

#define ADVANCE_L    1
#define RETREAT_L    -1

#define ADVANCE_R    1
#define RETREAT_R    -1

class DFRobot_MAX
{
public:
    DFRobot_MAX()
    {

    }

    ~DFRobot_MAX()
    {

    }

    void begin()
    {
        ;
    }

    bool buttonValue()
    {
        bool bValue = getBoolSignalValue(signalInfos[0].pName);
        return bValue;
    }

    void forward(int speed_l, int speed_r)
    {
        setIntSignalValue(signalInfos[1].pName, speed_l);
        setIntSignalValue(signalInfos[2].pName, speed_r);
    }
	
    void backward(int speed_l, int speed_r)
    {
        setIntSignalValue(signalInfos[1].pName, speed_l * -1);
        setIntSignalValue(signalInfos[2].pName, speed_r * -1);
    }

    void wheelL(int direction, int speed)
    {
        setIntSignalValue(signalInfos[1].pName, speed * direction);
    }

    void wheelR(int direction, int speed)
    {
        setIntSignalValue(signalInfos[2].pName, speed * direction);
    }

    void stopMotorL()
    {
        setIntSignalValue(signalInfos[1].pName, 0);
    }

    void stopMotorR()
    {
        setIntSignalValue(signalInfos[2].pName, 0);
    }	
};

DFRobot_MAX myMax;
